'\" Copyright 1990 Regents of the University of California
'\" Permission to use, copy, modify, and distribute this
'\" documentation for any purpose and without fee is hereby
'\" granted, provided that this notice appears in all copies.
'\" The University of California makes no representations about
'\" the suitability of this material for any purpose.  It is
'\" provided "as is" without express or implied warranty.
'\" 
'\" $Header: /user6/ouster/wish/man/RCS/menu.man,v 1.4 91/10/31 14:12:19 ouster Exp $ SPRITE (Berkeley)
'/" 
.\" The definitions below are for supplemental macros used in Sprite
.\" manual entries.
.\"
.\" .HS name section [date [version]]
.\"	Replacement for .TH in other man pages.  See below for valid
.\"	section names.
.\"
.\" .AP type name in/out [indent]
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS [type [name]]
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .VS
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
'	# Heading for Sprite man pages
.de HS
.if '\\$2'cmds'       .TH \\$1 1 \\$3 \\$4
.if '\\$2'lib'        .TH \\$1 3 \\$3 \\$4
.if '\\$2'tcl'        .TH \\$1 3 \\$3 \\$4
.if '\\$2'tk'         .TH \\$1 3 \\$3 \\$4
.if t .wh -1.3i ^B
.nr ^l \\n(.l
.ad b
..
'	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ie !"\\$3"" \{\
.ta \\n()Au \\n()Bu
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
'	# BS - start boxed text
'	# ^y = starting y location
'	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'	# VS - start vertical sidebar
'	# ^Y = starting y location
'	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'	# Special macro to handle page bottom:  finish off current
'	# box/sidebar if in box/sidebar mode, then invoked standard
'	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'	# DS - begin display
.de DS
.RS
.nf
.sp
..
'	# DE - end display
.de DE
.fi
.RE
.sp .5
..
.HS gpib cmds
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
gpib \- Command Interface to GPIB Command Library

.SH SYNOPSIS
\fBgpib\fI \fIcommand \fR[\fIparameter\fR]
.SH "COMMANDS"
.LP
.nf
.ta 4c 8c 12c
\fBfind\fR	\fBread\fR	\fBwrite\fR
\fBclose\fR	\fBclear\fR	\fBren\fR
\fBsic\fR	\fBcmd\fR	\fBwait\fR
.fi
.LP
.BE
.SH "INTRODUCTON"
.ta 4c
.IP
The GPIB Extension provides some essential commands from the 
GPIB Library to TCL/Tk. With this TCL commands you can initialize
your GPIB Interface, send strings and commands to devices and get
their measurement results.
.LP
.SH "DESCRIPTION"
.ta 4c
.LP
.nf
\fBfind\fR \fImnemonic\fR
.fi
.IP
Returns a device descriptor for the device with name \fImnemonic\fR
and initializes the device. The device must have been configured in
/etc/gpib.conf with correct mnemonic name and GPIB adress.
.LP
.nf
\fBread\fR \fIdevice\fR \fInum-bytes\fR
.fi
.IP
Reads \fInum-bytes\fR from \fIdevice\fR.
.LP
.nf
\fBwrite\fR \fIdevice\fR \fIstring\fR
.fi
.IP
Sends \fIstring\fR to the device.
.LP
.nf
\fBcmd\fR \fIdevice\fR \fIstring\fR
.fi
.IP
Sends \fIstring\fR as GPIB Command to device.
.LP
.nf
\fBren\fR \fIdevice\fR \fIflag\fR
.fi
.IP
If \fIflag\fR is 1 the device is set to Remote Enable (REM) state,
if 0 local mode is selected.
.LP

.nf
\fBsic\fR \fIdevice\fR
.fi
.IP
Performs the 'Send Interface Clear' command for 100us
.LP

.nf
\fBwait\fR \fIdevice\fR \fImasks\fR 
.fi
.IP
Waits for a event. Valid values for \fImasks\fR are:
.PP
	\fBsrq\fR   SRQ line is asserted.
.PP
	\fBtimo\fR  A timeout occured.
.LP

.nf
\fBclose\fR \fIdevice\fR 
.fi
.IP
Disconnects the desired device Descriptor from device and closes
the device driver's file handler.  
.LP

.SH KEYWORDS
gpib, ieee488

.SH BUGS
.PP
The Buffer size for read/write and command operations is limited to
512 bytes at this time. 
This could cause problems if you have more data to read/write.







